//---------------------------------------------------------------------
#include "MainWindow.h"
//---------------------------------------------------------------------
int32 test_thread(void *Owner)
{
	uint32 oldValue,newValue;

	oldValue=modifiers();
	while(true)
	{
		if((newValue=modifiers())!=oldValue)
		{
			((BWindow *)Owner)->PostMessage(new BMessage(MSG_SEND));
			oldValue=newValue;
		}
	}	
}
//---------------------------------------------------------------------
BAppMainWindow::BAppMainWindow(BRect frame,const char *title)
	:BWindow(frame,title,MAINWINDOW_WINDOWSTYLE,0)
{
	mainview=new BAppMainView(Bounds());	
	AddChild(mainview);

	cnt=0;
	tstthr=spawn_thread(test_thread,"TestThread",
	                    B_NORMAL_PRIORITY,(void *)this);
	resume_thread(tstthr); 
}
//---------------------------------------------------------------------
void BAppMainWindow::MessageReceived(BMessage *msg)
{
	switch(msg->what)
	{
		case MSG_SEND:
			{
				char buf[100];
				
				cnt++;
				sprintf(buf,"cnt=%d",cnt);
				mainview->strview->SetText(buf);
			}
			break;
		default:
			BWindow::MessageReceived(msg);
	}
}
//---------------------------------------------------------------------
BAppMainView::BAppMainView(BRect frame)
	:BView(frame,"bappmainview",B_FOLLOW_ALL,B_WILL_DRAW)
{
	BRect viewrect(Bounds());
	strview=new BStringView(BRect(8,68,viewrect.right-8,88),"strview",
	                        "NoData",
	                        B_FOLLOW_LEFT_RIGHT | B_FOLLOW_TOP);
	AddChild(strview);
}
//---------------------------------------------------------------------
bool BAppMainWindow::QuitRequested()
{
	kill_thread(tstthr); 
	be_app->PostMessage(B_QUIT_REQUESTED);
	return true;
};
//---------------------------------------------------------------------
